﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.FormattedLinkLabel;

namespace WindowsFormsApplication4
{
    class CheckEditorFormattedTextCreationFilter  : IUIElementCreationFilter
    {
        void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
        {
            if (parent is CheckEditorCheckBoxUIElement)
            {
                var textUIElement = parent.GetDescendant(typeof(TextUIElement)) as TextUIElement;
                if (null != textUIElement)
                {
                    var formattedTextUIElement = new FormattedTextUIElement(parent);
                    formattedTextUIElement.Rect = textUIElement.Rect;
                    formattedTextUIElement.Value = new ParsedFormattedTextValue(textUIElement.Text);

                    parent.ChildElements.Remove(textUIElement);
                    parent.ChildElements.Add(formattedTextUIElement);                    
                }
            }
        }

        bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
        {
            // Do nothing
            return false;
        }
    }
}
